

IMPLEMENTATION MODULE Error;

FROM String IMPORT
  Length,
  Concat;

FROM InOut IMPORT
  WriteString,
  WriteInt,
  WriteLn,
  Write;

  PROCEDURE WL(    S: ARRAY OF CHAR);
  (* WriteString + WriteLn *)
  BEGIN WriteString(S); WriteLn END WL;

  PROCEDURE WriteHeader;
  (* Ausgabe des oberen Grabsteinteils *)

  BEGIN
    WL("                     *****************               (__)  ");
    WL("               ******                 ******         (oo)  ");
    WL("         ******                             ******    \/   ");
    WL("   ******                 R. I. P.                ******   ");
    WL("***                                                     ***");
    WL("***                                                     ***");
    WL("***-----------------------------------------------------***");
    WL("***                                                     ***");
    WL("***         Tombstone productions proudly presents:     ***");
    WL("***                The end of your program!             ***");
    WL("***                                                     ***");
    WL("***-----------------------------------------------------***");
  END WriteHeader;

  PROCEDURE ApplicationTrap(    ModuleName   : ARRAY OF CHAR; 
                                ProcedureName: ARRAY OF CHAR;
                                Name         : ARRAY OF CHAR;
                                ErrorMessage : ARRAY OF CHAR);

    PROCEDURE FillLine(Name: ARRAY OF CHAR);

    CONST 
      KeywordLength = 40;

    VAR
      Index    : INTEGER;
      MaxNumber: INTEGER;

    BEGIN
      MaxNumber := KeywordLength;
      MaxNumber := MaxNumber-INTEGER(Length(Name));
      FOR Index:=1 TO MaxNumber DO Write(" ") END;
      WriteString("***")
    END FillLine;

  BEGIN
    WriteHeader; 
    WriteString("***  Module   : "); 
    WriteString(ModuleName);
    FillLine(ModuleName);
    WriteLn;
    WriteString("***  Procedure: ");
    WriteString(ProcedureName);
    FillLine(ProcedureName);
    WriteLn;
    WriteString("***  Error    : ");
    WriteString(ErrorMessage);
    FillLine(ErrorMessage);
    WriteLn;
    WriteString("***  Contact  : ");
    WriteString(Name);
    FillLine(Name);
    WriteLn;
    WL("***                                                     ***");
    WL("***********************************************************");
  END ApplicationTrap;

  PROCEDURE DisplayError(    Halt              : BOOLEAN; 
                             ExecuteTrapHandler: BOOLEAN;
                             ModuleName        : ARRAY OF CHAR; 
                             ProcedureName     : ARRAY OF CHAR;
                             Name              : ARRAY OF CHAR; 
                             ErrorMessage      : ARRAY OF CHAR);

  BEGIN
    ApplicationTrap(ModuleName,ProcedureName,Name,ErrorMessage);
    IF (Halt) THEN HALT END
  END DisplayError;

END Error.
